Index: distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AccordionsTest.java
===================================================================
--- distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AccordionsTest.java	(revision 0)
+++ distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AccordionsTest.java	(revision 0)
@@ -0,0 +1,120 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package com.xpn.xwiki.it.selenium;
+
+import com.xpn.xwiki.it.selenium.framework.AbstractXWikiTestCase;
+import com.xpn.xwiki.it.selenium.framework.AlbatrossSkinExecutor;
+import com.xpn.xwiki.it.selenium.framework.XWikiTestSuite;
+
+import junit.framework.Assert;
+import junit.framework.Test;
+
+/**
+ * Verify the Accordions features.
+ *
+ * @version $Id: $
+ */
+public class AccordionsTest extends AbstractXWikiTestCase {
+    public static Test suite()
+    {
+        XWikiTestSuite suite = new XWikiTestSuite("Verify the Accordions features");
+        suite.addTestSuite(AccordionsTest.class, AlbatrossSkinExecutor.class);
+        return suite;
+    }
+
+    public void setUp() throws Exception
+    {
+        super.setUp();
+        loginAsAdmin();
+    }
+    
+    /**
+     * <ul>
+     * <li>Validate presence of some preferences in XWiki.XWikiPreferences.</li>
+     * </ul>
+     */
+    public void testXWikiPreferences()
+    {
+    	 open(getUrl("XWiki", "XWikiPreferences", "admin"));
+         // Open Parameters tab and validate that its contents are displayed in less than 1000 milliseconds
+    	 Assert.assertEquals(true, getSelenium().getElementHeight("xwikiprefsparamsContent").intValue() > 0);
+    	 Assert.assertEquals(true, getSelenium().getAttribute("xwikiprefsparamsContent@style").indexOf("display: block;") > -1);
+         // Close Parameters tab and validate that its content are not displayed
+         getSelenium().click("xwikiprefsskinHeader");
+         getSelenium().setSpeed("1000");
+         Assert.assertEquals(0, getSelenium().getElementHeight("xwikiprefsparamsContent").intValue());
+         Assert.assertEquals(true, getSelenium().getAttribute("xwikiprefsparamsContent@style").indexOf("display: none;") > -1);
+         // Verify that Skin tab is open and its content is displayed
+    	 Assert.assertEquals(true, getSelenium().getElementHeight("xwikiprefsskinContent").intValue() > 0);
+    	 Assert.assertEquals(true, getSelenium().getAttribute("xwikiprefsskinContent@style").indexOf("display: block;") > -1);
+    }
+    
+    /**
+     * <ul>
+     * <li>Validate accordions features in XWiki.XWikiPreferences class edition.</li>
+     * </ul>
+     */
+    public void testXWikiPreferencesClassEdition()
+    {
+    	 open(getUrl("XWiki", "XWikiPreferences", "edit", "editor=class"));
+    	 getSelenium().setSpeed("1000");
+         // Open Skin tab and validate that its contents are displayed
+    	 Assert.assertEquals(true, getSelenium().getElementHeight("field_skin_content").intValue() > 0);
+    	 Assert.assertEquals(true, getSelenium().getAttribute("field_skin_content@style").indexOf("display: block;") > -1);
+         // Close Skin tab and validate that its content are not displayed
+         getSelenium().click("field_skin_title");
+         getSelenium().setSpeed("1000");
+         Assert.assertEquals(0, getSelenium().getElementHeight("field_skin_content").intValue());
+         Assert.assertEquals(true, getSelenium().getAttribute("field_skin_content@style").indexOf("display: none;") > -1);
+         // Open last tab and verify its contents are displayed in less then 1000 milliseconds
+         getSelenium().click("field_ldap_trylocal_title");
+         getSelenium().setSpeed("1000");
+         Assert.assertEquals(true, getSelenium().getElementHeight("field_ldap_trylocal_content").intValue() > 0);
+         Assert.assertEquals(true, getSelenium().getAttribute("field_ldap_trylocal_content@style").indexOf("display: block;") > -1);
+    }
+    
+    /**
+     * <ul>
+     * <li>Validate accordions features in XWiki.XWikiPreferences object edition.</li>
+     * </ul>
+     */
+    public void testXWikiPreferencesObjectEdition()
+    {
+    	 open(getUrl("XWiki", "XWikiPreferences", "edit", "editor=object"));
+    	 getSelenium().setSpeed("1000");
+         // Open XWikiPreferences tab and validate that its contents are displayed
+    	 getSelenium().click("field_XWiki.XWikiPreferences_0_title");
+         getSelenium().setSpeed("1000");
+    	 Assert.assertEquals(true, getSelenium().getElementHeight("field_XWiki.XWikiPreferences_0_content").intValue() > 0);
+    	 Assert.assertEquals(true, getSelenium().getAttribute("field_XWiki.XWikiPreferences_0_content@style").indexOf("display: block;") > -1);
+         // Modify some preferences and save the object
+         getSelenium().select("XWiki.XWikiPreferences_0_authenticate_edit", "Yes");
+         getSelenium().select("XWiki.XWikiPreferences_0_editor", "Text");
+         setFieldValue("XWiki.XWikiPreferences_0_leftPanels", "Panels.Navigation");
+         getSelenium().select("XWiki.XWikiPreferences_0_showLeftPanels", "Yes");
+         clickEditSaveAndView();
+         // Verify that Navigation panel is on the left and the contents of XWiki tab are displayed (since the current space is XWiki)
+         assertElementPresent("xwikinavXWiki");
+         Assert.assertEquals(true, getSelenium().getElementHeight("xwikinavXWikiContent").intValue() > 0);
+         Assert.assertEquals(true, getSelenium().getAttribute("xwikinavXWikiContent@style").indexOf("display: block;") > -1);   
+    }
+    
+    
+}

Property changes on: distribution-test\selenium-tests\src\test\it\com\xpn\xwiki\it\selenium\AccordionsTest.java
___________________________________________________________________
Name: svn:eol-style
   + native

Index: distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllTests.java
===================================================================
--- distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllTests.java	(revision 9229)
+++ distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllTests.java	(working copy)
@@ -64,6 +64,7 @@
         addTestCase(suite, WatchListTest.class);
         addTestCase(suite, KeyboardShortcutsTest.class);
         addTestCase(suite, UserProfileTest.class);
+        addTestCase(suite, AccordionsTest.class);
 
         return new XWikiTestSetup(suite);
     }