Index: xwiki-platform-core/xwiki-core/src/main/resources/ApplicationResources.properties
===================================================================
--- xwiki-platform-core/xwiki-core/src/main/resources/ApplicationResources.properties	(revision 9229)
+++ xwiki-platform-core/xwiki-core/src/main/resources/ApplicationResources.properties	(working copy)
@@ -707,6 +707,9 @@
 core.rename.alreadyExists=A document with the given name (<a href="{1}">{0}</a>) already exists. Please provide a different name.
 rename=Rename
 
+# Copy
+copy=Copy
+
 # Paging links
 web.paging.pageNumberOf=Page {0} of {1}
 web.paging.firstPage=&laquo; First
@@ -959,6 +962,7 @@
 rightsmanager.createnewgroup=Create new group
 rightsmanager.creategroup=Create group
 rightsmanager.groupexist=__name__ cannot be used for the group name, as another document with this name already exists.
+rightsmanager.rights=Rights
 
 ui.ajaxTable.loading=Loading...
 
@@ -971,4 +975,4 @@
 platform.core.invalidUrl=This is not a valid URL
 platform.core.action.objectRemove.noClassnameSpecified=No object type specified.
 platform.core.action.objectRemove.noObjectSpecified=No object specified.
-platform.core.action.objectRemove.invalidObject=Invalid object specified.
\ No newline at end of file
+platform.core.action.objectRemove.invalidObject=Invalid object specified.
Index: xwiki-platform-skins/albatross/src/main/resources/albatross/usersandgroups.css
===================================================================
--- xwiki-platform-skins/albatross/src/main/resources/albatross/usersandgroups.css	(revision 9229)
+++ xwiki-platform-skins/albatross/src/main/resources/albatross/usersandgroups.css	(working copy)
@@ -1,7 +1,6 @@
 /* USERS SCROLLING SYSTEM */
-
 div.scrollbar {
-  overflow: auto;
+  overflow: auto !important;
   height: 250px;
   margin: 0px;
   padding: 0px;
@@ -78,7 +77,7 @@
 }
 
 
-#userstable, #groupstable, #usersandgroupstable {
+#userstable, #groupstable, #usersandgroupstable, #alldocstable {
   width: 100%;
   position: relative;
   left: 4px;
Index: xwiki-platform-skins/toucan/src/main/resources/toucan/usersandgroups.css
===================================================================
--- xwiki-platform-skins/toucan/src/main/resources/toucan/usersandgroups.css	(revision 9229)
+++ xwiki-platform-skins/toucan/src/main/resources/toucan/usersandgroups.css	(working copy)
@@ -82,7 +82,7 @@
 	padding: 3px 0 3px 10px;
 }
 
-#userstable, #groupstable, #usersandgroupstable {
+#userstable, #groupstable, #usersandgroupstable, #alldocstable {
     width: 100%;
     position: relative;
     border: 5px solid #fff;
@@ -183,4 +183,4 @@
 
 .addlabel {
    font-weight: bold;
-}
\ No newline at end of file
+}
Index: xwiki-product-enterprise/distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllDocsTest.java
===================================================================
--- xwiki-product-enterprise/distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllDocsTest.java	(revision 0)
+++ xwiki-product-enterprise/distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllDocsTest.java	(revision 0)
@@ -0,0 +1,107 @@
+/*
+ * See the NOTICE file distributed with this work for additional
+ * information regarding copyright ownership.
+ *
+ * This is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU Lesser General Public License as
+ * published by the Free Software Foundation; either version 2.1 of
+ * the License, or (at your option) any later version.
+ *
+ * This software is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+ * Lesser General Public License for more details.
+ *
+ * You should have received a copy of the GNU Lesser General Public
+ * License along with this software; if not, write to the Free
+ * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
+ * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
+ */
+package com.xpn.xwiki.it.selenium;
+
+import com.xpn.xwiki.it.selenium.framework.AbstractXWikiTestCase;
+import com.xpn.xwiki.it.selenium.framework.AlbatrossSkinExecutor;
+import com.xpn.xwiki.it.selenium.framework.XWikiTestSuite;
+
+import junit.framework.Assert;
+import junit.framework.Test;
+
+/**
+ * Verify the table view for AllDocs wiki document.
+ *
+ * @version $Id: $
+ */
+public class AllDocsTest extends AbstractXWikiTestCase {
+    public static Test suite()
+    {
+        XWikiTestSuite suite = new XWikiTestSuite("Verify the table view for AllDocs wiki document");
+        suite.addTestSuite(AllDocsTest.class, AlbatrossSkinExecutor.class);
+        return suite;
+    }
+
+    public void setUp() throws Exception
+    {
+        super.setUp();
+        loginAsAdmin();
+    }
+    
+    /**
+     * <ul>
+     * <li>Validate presence of "Actions" column in table view for administrator.</li>
+     * <li>Validate absence of "Actions" column for users without administration rights.</li>
+     * <li>Validate presence of "Treeview" page, after typing "treeview" in the "Page" input suggest.</li>
+     * <li>Validate "Copy" link action.</li>
+     * <li>Validate "Delete" link action.</li>
+     * <li>Validate "Rename" link action.</li>
+     * <li>Validate "Rights" link action.</li>
+     * </ul>
+     */
+    public void testTableViewActions()
+    {
+      open(getUrl("Main", "AllDocs"));
+      assertElementPresent("//td[text()='Actions']");
+      
+      // Verify that the user is logged in and log out
+      if (isAuthenticated()) {
+          logout();
+      }
+      assertElementNotPresent("//td[text()='Actions']");
+      
+      // Login again
+      loginAsAdmin();
+      open(getUrl("Main", "AllDocs"));
+      
+      // Test Copy action
+      getSelenium().typeKeys("page", "Treeview");
+      assertElementPresent("//td[@class='pagename']/a[text()='Treeview']");
+      assertElementPresent("link=Copy");
+      clickLinkWithText("Copy");
+      setFieldValue("targetdoc", "New.TreeviewCopy");
+      getSelenium().click("//input[@value='Copy']");
+      open(getUrl("Main","AllDocs"));
+      // Test suggestions for Page and Space
+      getSelenium().typeKeys("space", "New");
+      getSelenium().typeKeys("page", "Treeviewcopy");
+      assertElementPresent("//td[@class='pagename']/a[text()='TreeviewCopy']");
+      
+      // Test Rename action
+      clickLinkWithLocator("//tbody/tr/td/a[text()='Rename']");
+      setFieldValue("newPageName", "TreeviewCopyRenamed");
+      clickLinkWithLocator("//input[@value='Rename']");
+      open(getUrl("Main", "AllDocs"));
+      getSelenium().typeKeys("page", "treeviewcopy");
+      assertElementPresent("//td[@class='pagename']/a[text()='TreeviewCopyRenamed']");
+      
+      // Test Delete action
+      clickLinkWithLocator("//tbody/tr/td/a[text()='Delete']");
+      clickLinkWithLocator("//input[@value='yes']");
+      assertTextPresent("The document has been deleted.");
+      open(getUrl("Main", "AllDocs"));
+      getSelenium().typeKeys("page", "treeview");
+      assertElementNotPresent("//td[@class='pagename']/a[text()='TreeviewCopyRenamed']");
+      
+      // Test Rights action
+      clickLinkWithLocator("//tbody/tr/td/a[text()='Rights']");
+      Assert.assertEquals("Editing rights for Treeview", getTitle());
+    }
+}

Property changes on: xwiki-product-enterprise\distribution-test\selenium-tests\src\test\it\com\xpn\xwiki\it\selenium\AllDocsTest.java
___________________________________________________________________
Name: svn:eol-style
   + native

Index: xwiki-product-enterprise/distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllTests.java
===================================================================
--- xwiki-product-enterprise/distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllTests.java	(revision 9229)
+++ xwiki-product-enterprise/distribution-test/selenium-tests/src/test/it/com/xpn/xwiki/it/selenium/AllTests.java	(working copy)
@@ -64,6 +64,7 @@
         addTestCase(suite, WatchListTest.class);
         addTestCase(suite, KeyboardShortcutsTest.class);
         addTestCase(suite, UserProfileTest.class);
+        addTestCase(suite, AllDocsTest.class);
 
         return new XWikiTestSetup(suite);
     }
Index: xwiki-product-enterprise/wiki/src/main/resources/Main/AllDocs
===================================================================
--- xwiki-product-enterprise/wiki/src/main/resources/Main/AllDocs	(revision 9229)
+++ xwiki-product-enterprise/wiki/src/main/resources/Main/AllDocs	(working copy)
@@ -12,9 +12,9 @@
 <customClass></customClass>
 <contentAuthor>XWiki.Admin</contentAuthor>
 <creationDate>1107744419000</creationDate>
-<date>1184180552000</date>
-<contentUpdateDate>1184180552000</contentUpdateDate>
-<version>1.53</version>
+<date>1207750266000</date>
+<contentUpdateDate>1207750266000</contentUpdateDate>
+<version>5.1</version>
 <title></title>
 <template></template>
 <defaultTemplate></defaultTemplate>
@@ -53,66 +53,47 @@
 <tags/>
 </property>
 </object>
-<content>1 Documents on this Wiki
-
-#if((!$view) || ($view == ""))
-  #set($view = $request.getParameter("view"))
-  #if((!$view) || ($view == ""))
-    #set ($view = "index")
-  #end
-#end
-
-&lt;div class="floatcontainer"&gt;
-&lt;ul class="xwikitabbar"&gt;
-&lt;li id="xwikiindex"#if($view == "index") class="active"#end&gt;&lt;a href="$doc.getURL("view", "view=index&amp;amp;$!param")"&gt;Index&lt;/a&gt;&lt;/li&gt;
-&lt;li id="xwikitreeview"#if($view == "tree") class="active"#end&gt;&lt;a href="$doc.getURL("view", "view=tree&amp;amp;$!param")"&gt;Tree&lt;/a&gt;&lt;/li&gt;
-&lt;li id="xwikiorphansview"#if($view == "orphans") class="active"#end&gt;&lt;a href="$doc.getURL("view", "view=orphans&amp;amp;$!param")"&gt;Orphaned Pages&lt;/a&gt;&lt;/li&gt;
-&lt;/ul&gt;
-&lt;/div&gt;
-&lt;div id="xwikieditcontent" class="clear"&gt;
-
-## ==============================================
-## If view=index then displays the index of pages
-## ==============================================
-#if ($view == "index")
-
-&lt;div style="text-align:center"&gt;
-[0-9&gt;$doc.fullName?view=index&amp;amp;letter=09] -
-#foreach($letter in ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z'])
-  [$letter&gt;$doc.fullName?view=index&amp;amp;letter=${letter}] -
-#end 
-[#&gt;$doc.fullName]
-&lt;/div&gt;
-
-#if(!$request.letter || $request.letter == "")
-  #set($sql = "1=1 order by doc.name asc")
-#elseif($request.letter != "09")
-  #set($sql = "doc.name like '${request.letter}%' or doc.name like '${request.letter.toLowerCase()}%' order by doc.name asc")
-#else
-  #set($sql = "substring(doc.name, 1, 1) &gt;= '0' and substring(doc.name, 1, 1) &lt;= '9' order by doc.name asc")
-#end
-
-#set($nb = 0)
-#set ($list = $xwiki.searchDocuments($sql , $nb , 0))
-
-#includeForm("XWiki.Results")
-
-#elseif ($view == "tree")
-
-## ==============================================
-## If view=tree then displays the treeview
-## ==============================================
-
-#includeTopic("XWiki.Treeview")
-
-#else
-## ==============================================
-## If view=orphans then display orphaned pages
-## ==============================================
-
-#includeTopic("XWiki.OrphanedPages")
-
-#end
-
+<content>1 Documents on this Wiki
+
+#if((!$view) || ($view == ""))
+  #set($view = $request.getParameter("view"))
+  #if((!$view) || ($view == ""))
+    #set ($view = "index")
+  #end
+#end
+
+&lt;div class="floatcontainer"&gt;
+&lt;ul class="xwikitabbar"&gt;
+&lt;li id="xwikiindex"#if($view == "index") class="active"#end&gt;&lt;a href="$doc.getURL("view", "view=index&amp;amp;$!param")"&gt;Index&lt;/a&gt;&lt;/li&gt;
+&lt;li id="xwikitreeview"#if($view == "tree") class="active"#end&gt;&lt;a href="$doc.getURL("view", "view=tree&amp;amp;$!param")"&gt;Tree&lt;/a&gt;&lt;/li&gt;
+&lt;li id="xwikiorphansview"#if($view == "orphans") class="active"#end&gt;&lt;a href="$doc.getURL("view", "view=orphans&amp;amp;$!param")"&gt;Orphaned Pages&lt;/a&gt;&lt;/li&gt;
+&lt;/ul&gt;
+&lt;/div&gt;
+&lt;div id="xwikieditcontent" class="clear"&gt;
+
+## ==============================================
+## If view=index then displays the index of pages
+## ==============================================
+#if ($view == "index")
+
+#includeTopic("XWiki.Tableview")
+
+#elseif ($view == "tree")
+
+## ==============================================
+## If view=tree then displays the treeview
+## ==============================================
+
+#includeTopic("XWiki.Treeview")
+
+#else
+## ==============================================
+## If view=orphans then display orphaned pages
+## ==============================================
+
+#includeTopic("XWiki.OrphanedPages")
+
+#end
+
 &lt;/div&gt;</content>
 </xwikidoc>
Index: xwiki-product-enterprise/wiki/src/main/resources/XWiki/Tableresults
===================================================================
--- xwiki-product-enterprise/wiki/src/main/resources/XWiki/Tableresults	(revision 0)
+++ xwiki-product-enterprise/wiki/src/main/resources/XWiki/Tableresults	(revision 0)
@@ -0,0 +1,166 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<xwikidoc>
+<web>XWiki</web>
+<name>Tableresults</name>
+<language></language>
+<defaultLanguage></defaultLanguage>
+<translation>0</translation>
+<parent></parent>
+<creator>XWiki.Admin</creator>
+<author>XWiki.Admin</author>
+<customClass></customClass>
+<contentAuthor>XWiki.Admin</contentAuthor>
+<creationDate>1207827477000</creationDate>
+<date>1207906346000</date>
+<contentUpdateDate>1207906346000</contentUpdateDate>
+<version>63.1</version>
+<title></title>
+<template></template>
+<defaultTemplate></defaultTemplate>
+<validationScript></validationScript>
+<comment></comment>
+<minorEdit>false</minorEdit>
+<content>{pre}
+#set( $offset = $xwiki.parseInt( $request.get( "offset" ) ) )
+## offset starts from 0 in velocity and 1 in javascript
+#set( $off = $offset - 1 )
+#set( $limit = $xwiki.parseInt( $request.get( "limit" ) ) )
+
+#set($page = $request.get("page"))
+#set($space = $request.get("space"))
+#set($author = $request.get("author"))
+#set($formatDate = "yyyy MMMM dd, HH:mm")
+
+#if($page) 
+  #set($page = $page.trim().toLowerCase())
+  #set($sql = "where lower(doc.name) like '%${page}%'")
+#else #set($sql = "where lower(doc.name) &lt;&gt; ''") #end
+#if($space)  
+  #set($space = $space.trim().toLowerCase())
+  #set($sql = $sql + "and lower(doc.web) like '%${space}%'") 
+#end
+#if($author) 
+  #set($author = $author.trim().toLowerCase())
+  #set($sql = $sql + "and lower(doc.author) like '%${author}%'") 
+#end
+#set($sql = $sql + "order by doc.name")
+
+#set($items = $xwiki.searchDocuments($sql, $limit, $off))
+#set($countItems= $xwiki.searchDocuments($sql).size())
+
+### json starts
+{ 
+"totalrows": $countItems,
+"returnedrows": #if($items.size() &lt; $limit) $items.size() #else $limit #end,
+"offset": $offset,
+"reqNo": $request.reqNo,
+"rows": [
+#foreach( $item in $items )
+##** fullname **##
+   #if($item.class == "class com.xpn.xwiki.plugin.lucene.SearchResult")
+     #set($itemfullname = "${item.wiki}:${item.web}.${item.name}")
+   #else
+     #set($itemfullname = "${context.database}:${item}")
+   #end
+##** itemurl **##
+   #set($itemurl = $xwiki.getURL($itemfullname))
+##** access level **##
+   #set($acclev = $xwiki.hasAccessLevel("view", $context.user, $itemfullname))
+##** bentrydoc **##
+   #if ($item.class == "class java.lang.String")
+   	  #set($bentrydoc = $xwiki.getDocument($item))
+   #elseif ($item.class == "class com.xpn.xwiki.plugin.lucene.SearchResult")
+      #set($bentrydoc = $item)
+   #end
+##** item date **##
+   #set($itemdate = $!xwiki.formatDate($!bentrydoc.date, $formatDate))
+##** page **##
+   #set($page = $bentrydoc.name)
+   #set($ptitle = "$!bentrydoc.getDisplayTitle()")
+   #if($ptitle == $page)
+   	#set($ptitle = "")
+   #end
+##** space **##
+   #set($space = $bentrydoc.web)
+   #set($spaceurl = $xwiki.getURL("${bentrydoc.wiki}:${bentrydoc.web}.WebHome"))
+##** wiki **##
+   #if($xwiki.isVirtual())
+     #set($wiki = $bentrydoc.wiki)
+     #set($wikiurl = $xwiki.getURL("${bentrydoc.wiki}:Main.WebHome"))
+   #end
+##** is attachment **##
+   #set($isattach = false)
+   #if ($bentrydoc.type)
+     #set ($ptitle = $xwiki.getDocument($itemfullname).getDisplayTitle())
+     #if ($bentrydoc.type == "attachment")
+       #set($isattach = true)
+       #set($filename = $bentrydoc.filename)
+     #end
+   #end
+##** has new comment **##
+    #set($hasnewcomm = false)
+    #set($cclass = $xwiki.getDocument("XWiki.XWikiComments").getxWikiClass())
+    #if($xwiki.getWebPreferenceAsInt("commentsorder", 1) == 0)
+      #set($comments = $bentrydoc.getComments())
+    #else
+      #set($comments = $bentrydoc.getComments(false))
+    #end
+    #if($comments &amp;&amp; $comments.size()&gt;0)
+      #set($i = 0)
+      #set($cobj = $comments.get($i))
+      #set($date = $cobj.getXWikiObject().get("date").value)
+      #if($date)
+        #set($date1 = $!xwiki.formatDate($date, $formatDate))
+      #end
+      #if($itemdate.equals($date1))
+        #set($hasnewcomm = true)
+      #end
+    #end
+##** author **##
+    #if($hasnewcomm)
+      #set($author = $cobj.author)
+    #else
+      #set($author = $bentrydoc.author)
+    #end
+    #set($authorpage = $xwiki.getURL($author))
+    #set($dot = $author.indexOf('.') + 1)
+    #if($dot &gt; 1)
+      #set($author = $author.substring($dot))
+    #end
+##** actions **##
+   #set($copy = $xwiki.getURL("XWiki.CopyDocument", "view", "sourcedoc=${util.encodeURI($itemfullname)}"))
+   #set($delete = $bentrydoc.getURL("delete"))
+   #set($rename = $bentrydoc.getURL("view", "xpage=rename&amp;amp;step=1"))
+   #set($rights = $bentrydoc.getURL("edit", "editor=rights"))
+   
+   #if( $velocityCount &gt; 1 ) , #end
+   {"acclev"    : $acclev,
+    "page"      : "$page", 
+    "url"       : "$itemurl",
+    "title"     : "$ptitle",
+    "space"     : "$space",
+    "spaceurl"  : "$spaceurl",
+    "isvirtual" : $xwiki.isVirtual(),
+   #if($xwiki.isVirtual())
+    "wiki"      : "$wiki",
+    "wikiurl"   : "$!wikiurl",
+   #end
+    "date"      : "$itemdate",
+    "author"    : "$author",
+    "authorpage" : "$!authorpage",
+    "hasnewcom" : $hasnewcomm,
+   #if($isattach)
+    "filename"  : "$filename",
+   #end
+    "hasadmin"  : $xwiki.hasAdminRights(),
+    "copyurl"   : "$copy",
+    "deleteurl" : "$delete",
+    "renameurl" : "$rename",
+    "rightsurl" : "$rights"
+  }
+#end
+]}
+### end of json
+{/pre}
+</content></xwikidoc>
Index: xwiki-product-enterprise/wiki/src/main/resources/XWiki/Tableview
===================================================================
--- xwiki-product-enterprise/wiki/src/main/resources/XWiki/Tableview	(revision 0)
+++ xwiki-product-enterprise/wiki/src/main/resources/XWiki/Tableview	(revision 0)
@@ -0,0 +1,140 @@
+<?xml version="1.0" encoding="ISO-8859-1"?>
+
+<xwikidoc>
+<web>XWiki</web>
+<name>Tableview</name>
+<language></language>
+<defaultLanguage></defaultLanguage>
+<translation>0</translation>
+<parent></parent>
+<creator>XWiki.Admin</creator>
+<author>XWiki.Admin</author>
+<customClass></customClass>
+<contentAuthor>XWiki.Admin</contentAuthor>
+<creationDate>1207750266000</creationDate>
+<date>1207915279000</date>
+<contentUpdateDate>1207915279000</contentUpdateDate>
+<version>49.1</version>
+<title></title>
+<template></template>
+<defaultTemplate></defaultTemplate>
+<validationScript></validationScript>
+<comment></comment>
+<minorEdit>false</minorEdit>
+<object>
+<class>
+<name>XWiki.TagClass</name>
+<customClass></customClass>
+<customMapping></customMapping>
+<defaultViewSheet></defaultViewSheet>
+<defaultEditSheet></defaultEditSheet>
+<defaultWeb></defaultWeb>
+<nameField></nameField>
+<validationScript></validationScript>
+<tags>
+<cache>0</cache>
+<displayType>input</displayType>
+<multiSelect>1</multiSelect>
+<name>tags</name>
+<number>1</number>
+<prettyName>Tags</prettyName>
+<relationalStorage>1</relationalStorage>
+<separator> </separator>
+<separators> ,|</separators>
+<size>30</size>
+<unmodifiable>0</unmodifiable>
+<values></values>
+<classType>com.xpn.xwiki.objects.classes.StaticListClass</classType>
+</tags>
+</class>
+<name>XWiki.Tableview</name>
+<number>0</number>
+<className>XWiki.TagClass</className>
+<property>
+<tags/>
+</property>
+</object>
+<content>&lt;div id="ajax-loader"&gt;$msg.get("ui.ajaxTable.loading")&lt;br /&gt;
+  &lt;img src="$xwiki.getSkinFile('icons/ajax-loader.gif')" alt="$msg.get('ui.ajaxTable.loading')" title="" /&gt;
+&lt;/div&gt;
+&lt;table id="alldocstable"&gt;
+&lt;tr&gt;
+ &lt;td colspan="2" style="padding-top:10px;"&gt;
+   &lt;span id="showLimits"&gt;&lt;/span&gt;
+ &lt;/td&gt;
+&lt;/tr&gt;
+&lt;tr&gt;&lt;td style="width:100%"&gt;
+      &lt;table class="display"&gt;
+       &lt;thead class="theader"&gt;
+          &lt;tr&gt;
+            &lt;td&gt;$msg.get("wikiname")&lt;/td&gt;
+            &lt;td&gt;$msg.get("wikiweb")&lt;/td&gt;
+            #if($xwiki.isVirtual())&lt;td&gt;$msg.get("editwiki")&lt;/td&gt;#end
+            &lt;td&gt;$msg.get("date")&lt;/td&gt;
+            &lt;td&gt;$msg.get("lastauthor")&lt;/td&gt;
+            #if($xwiki.hasAdminRights())&lt;td&gt;$msg.get("core.menu.actions")&lt;/td&gt;#end          
+          &lt;/tr&gt;
+          &lt;tr id="table-filters"&gt;
+              &lt;td&gt;&lt;input name="page" type="text"/&gt;&lt;/td&gt;
+              &lt;td&gt;&lt;input name="space" type="text"/&gt;&lt;/td&gt;
+              #if($xwiki.isVirtual())&lt;td&gt;&lt;/td&gt;#end
+              &lt;td&gt;&lt;/td&gt; ## date
+              &lt;td&gt;&lt;input name="author" type="text" /&gt;&lt;/td&gt;
+              #if($xwiki.hasAdminRights())&lt;td&gt;&lt;/td&gt;#end
+          &lt;/tr&gt;
+       &lt;/thead&gt;
+       &lt;tbody id="display1"&gt;&lt;tr&gt;&lt;td&gt;&amp;nbsp;&lt;/td&gt;&lt;/tr&gt;&lt;/tbody&gt;
+      &lt;/table&gt;&lt;/td&gt;
+      &lt;td valign="top"&gt;
+        &lt;div id="scrollbar1" class="scrollbar"&gt;&lt;div class="inscrollbar"&gt;&amp;nbsp;&lt;/div&gt;&lt;/div&gt;
+      &lt;/td&gt;
+    &lt;td id="buff"&gt;&lt;/td&gt;
+&lt;/tr&gt;
+&lt;/table&gt;
+#set($url = "$xwiki.getURL('XWiki.Tableresults')?xpage=plain")
+{pre}
+&lt;script type="text/javascript"&gt;
+function displayAllDocs(row, i, table)
+{
+  var a = new Element('a', {'href' : row.url}).update(row.page);
+  var page = new Element('td', {'class' : 'pagename'}).update(a);
+  var tr = new Element('tr', {'class' : (i % 2 == 0) ? 'even' : 'odd'} ).update(page);
+  var spaceurl = new Element('a', {'href': row.spaceurl}).update(row.space);
+  var space = new Element('td').update(spaceurl);
+  tr.appendChild(space);
+  if(row.virtual) {
+   var wikiurl = new Element('a', {'href' : row.wikiurl}).update(row.wiki);
+   var wiki = new Element('td').update(wikiurl);
+   tr.appendChild(wiki);
+  }
+  var date = new Element('td').update(row.date);
+  tr.appendChild(date);
+  if(row.authorpage) {
+  	var authorpage = new Element('a', {'href' : row.authorpage}).update(row.author);
+  	var author = new Element('td').update(authorpage);
+  }
+  else
+    var author = new Element('td').update(row.author);
+  tr.appendChild(author);
+  var copy =   new Element('a', {'href' : row.copyurl}).update("$msg.get('copy')");
+  var del = new Element('a', {'href' : row.deleteurl}).update("$msg.get('delete')");
+  var rename = new Element('a', {'href' : row.renameurl}).update("$msg.get('rename')");
+  var rights = new Element('a', {'href' : row.rightsurl}).update("$msg.get('rightsmanager.rights')");
+  if(row.hasadmin) {
+  	var actions = new Element('td');
+  	actions.appendChild(copy);
+  	actions.appendChild(new Element('span').update("-"));
+  	actions.appendChild(del);
+  	actions.appendChild(new Element('span').update("-"));
+  	actions.appendChild(rename);
+  	actions.appendChild(new Element('span').update("-"));
+  	actions.appendChild(rights);
+  	tr.appendChild(actions);
+  }
+
+  return tr;
+}
+var ta = new ASSTable("$url", 15, "display1", "scrollbar1", "alldocstable", displayAllDocs, true);
+&lt;/script&gt;
+{/pre}</content>
+</xwikidoc>